class VoterController < ApplicationController
  layout 'main'
  require_dependency "voter"
  require_dependency "vote"
  require_dependency "election"

  def index
    if params[:urlpassword]
      password = params[:urlpassword]
    else
      password = nil
    end

    if @voter = FullVoter.find(:all, :conditions =>
                                       [ "password = ?", password ] )[0]
      @voter.vote = Vote.new if @voter.vote.nil?
      @voter.vote.set_defaults! if @voter.vote.rankings.empty?

      @election = @voter.election
      @sidebar_content = render_to_string(:partial => 'sortable_vote')
      render :action => 'full_vote'
    elsif params[:urlpassword] 
      redirect_to :action => 'index'
    end
  end

  def login
    if params[:vote] and params[:vote][:password]
      redirect_to votepassword_url( :action => 'index', :urlpassword => params[:vote][:password])
    else
      redirect_to :action => 'index'
    end
  end
  
  def review
    if authenticate
      @voter.vote.time = Time.now
      @voter.vote.save
      @voter.reload
    else
      redirect_to :action => 'index'
    end
  end

  def confirm
    if authenticate
      @voter.vote.confirm!
      render :action => 'thanks'
    else
      redirect_to :action => 'index'
    end
  end
  
  def reminder
    if params[:email]
      voter_array= FullVoter.find(:all, :conditions => ["email = ?", params[:email]])
      voter_array.delete_if {|voter| voter.election.active == 0}
      unless voter_array.empty?
        VoterNotify.deliver_reminder(voter_array)
      end
      render :action => 'reminder_sent'
    end
  end
  
  
  private
  def authenticate
    password = params[:id]
    @voter = FullVoter.find(:all, :conditions => [ "password = ?", password ] )[0]
  end
end

